package com.template.controller;


import com.template.api.SmartBuildControllerAPI;
import com.template.common.utils.paramUtils;
import com.template.model.pojo.SmartBuild;
import com.template.model.result.CommonResult;
import com.template.model.result.PageUtils;
import com.template.services.SmartBuildService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ceshi
 * @since 2023-12-04
 */
@RestController
public class SmartBuildController implements SmartBuildControllerAPI {

    @Autowired
    private SmartBuildService smartBuildService;

    /**
     * 新增楼栋
     * @param smartApply 楼栋数据
     * @param bindingResult
     * @return
     */
    @Override
    public CommonResult insertSmartBuild(SmartBuild smartApply, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = smartBuildService.insertSmartBuild(smartApply);

        return result > 0 ? CommonResult.ok("添加成功") : CommonResult.fail("添加失败");
    }

    /**
     * 更新楼栋
     * @param sa 楼栋数据
     * @param bindingResult
     * @return
     */
    @Override
    public CommonResult updateSmartBuildById(SmartBuild sa, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = smartBuildService.updateSmartBuild(sa);
        return result > 0 ? CommonResult.ok("修改成功") : CommonResult.fail("修改失败");
    }

    /**
     * 楼栋分页数据查询
     * @param currentPage 当前页数
     * @param pageCount 一页数据条数
     * @param name 查询名称
     * @return
     */
    @Override
    public CommonResult queryPageSmartBuilds(int currentPage, int pageCount, String name) {
        PageUtils<SmartBuild> result = smartBuildService.queryPageSmartBuilds(currentPage, pageCount, name);

        return CommonResult.ok(result);
    }


    @Override
    public CommonResult deleteSmartBuildById(int id) {

        SmartBuild data = smartBuildService.getSmartById(id);

        if(data == null){
            return CommonResult.fail("当前数据不存在，删除失败！");
        }

        int result = smartBuildService.deleteSmartBuildById(id);

        return result > 0 ? CommonResult.ok("删除成功") : CommonResult.fail("删除失败");
    }
}

